﻿using Infragistics.Controls.Schedules;
using Infragistics.Controls.Schedules.Primitives;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamSchedule_AllowDragging
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new MainWindowViewModel();
        }
    }

    public sealed class MainWindowViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Resource> _resources;

        public ObservableCollection<Resource> Resources
        {
            get { return _resources; }
            set
            {
                _resources = value;
                NotifyPropertyChanged("Resources");
            }
        }

        private ObservableCollection<ResourceCalendar> _resourceCalendars;

        public ObservableCollection<ResourceCalendar> ResourceCalendars
        {
            get { return _resourceCalendars; }
            set
            {
                _resourceCalendars = value;
                NotifyPropertyChanged("ResourceCalendars");
            }
        }

        private ObservableCollection<Appointment> _appointments;

        public ObservableCollection<Appointment> Appointments
        {
            get { return _appointments; }
            set
            {
                _appointments = value;
                NotifyPropertyChanged("Appointments");
            }
        }


        public MainWindowViewModel()
        {
            Resources = new ObservableCollection<Resource>();
            var res1 = new Resource() { Id = "Resouce1", Name = "Resouce1" };
            var res2 = new Resource() { Id = "Resouce2", Name = "Resouce2" };
            var res3 = new Resource() { Id = "Resouce3", Name = "Resouce3" };
            Resources.Add(res1);
            Resources.Add(res2);
            Resources.Add(res3);

            ResourceCalendars = new ObservableCollection<ResourceCalendar>();
            var cal1 = new ResourceCalendar() { Id = "ResourceCalendar1", Name = "ResourceCalendar1", OwningResourceId = "Resouce1" };
            var cal2 = new ResourceCalendar() { Id = "ResourceCalendar2", Name = "ResourceCalendar2", OwningResourceId = "Resouce2" };
            var cal3 = new ResourceCalendar() { Id = "ResourceCalendar3", Name = "ResourceCalendar3", OwningResourceId = "Resouce3" };
            ResourceCalendars.Add(cal1);
            ResourceCalendars.Add(cal2);
            ResourceCalendars.Add(cal3);
            Appointments = new ObservableCollection<Appointment>();
            var app1 = new Appointment()
            {
                Id = "Appointment1",
                OwningResourceId = "Resouce1",
                OwningCalendarId = "ResourceCalendar1",
                Subject = "Appointment1",
                Location = "Location1",
                Start = DateTime.Today.AddHours(10),
                End = DateTime.Today.AddHours(12),
                StartTimeZoneId = "Tokyo Standard Time",
                EndTimeZoneId = "Tokyo Standard Time",

            };
            var app2 = new Appointment()
            {
                Id = "Appointment2",
                OwningResourceId = "Resouce2",
                OwningCalendarId = "ResourceCalendar2",
                Subject = "Appointment2",
                Location = "Location2",
                Start = DateTime.Today.AddHours(5),
                End = DateTime.Today.AddHours(10),
                StartTimeZoneId = "Tokyo Standard Time",
                EndTimeZoneId = "Tokyo Standard Time",

            };
            var app3 = new Appointment()
            {
                Id = "Appointment3",
                OwningResourceId = "Resouce3",
                OwningCalendarId = "ResourceCalendar3",
                Subject = "Appointment3",
                Location = "Location3",
                Start = DateTime.Today.AddHours(7),
                End = DateTime.Today.AddHours(16),
                StartTimeZoneId = "Tokyo Standard Time",
                EndTimeZoneId = "Tokyo Standard Time",

            };
            Appointments.Add(app1);
            Appointments.Add(app2);
            Appointments.Add(app3);
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
